/************************************************************************
 *									*
 *		qr|QRQbCu				*
 *									*
 *				: qr|QRQb@bgQ		*
 *		t@C	: rs2.c					*
 *		쐬		: s.aizawa				*
 *									*
 ************************************************************************/

#include	<stddef.h>
#include	<stdlib.h>
#include	<string.h>
#include	<dos.h>
#include	<conio.h>
#include	"rs232c.h"

/*	[NGA	*/
u_char	rs2_cmdreg;			/* R}hWX^Z[uGA */
static	int	open_flag;		/* I[vtO */
static	int	duplex;			/* d[h */
static	int	*rbufp;			/* Mobt@|C^ */
static	u_int	rbufsize;		/* Mobt@ */
static	int	alloc_flag;		/* Mobt@AP[VtO */
static	u_char	imreg;			/* 荞݃}XNWX^ */
static	u_int	read_ptr;		/* Mobt@ǂݍ݃|C^ */
static	u_int	write_ptr;		/* Mobt@݃|C^ */
static	u_int	rcv_count;		/* M */
static	int	flow_ctrl;		/* t[ */
static	u_int	flow_off;		/* M҂킹Jnobt@TCY */
static	u_int	flow_on;		/* M҂킹obt@TCY */
static	int	flow_rflag;		/* Mt[tO */
static	int	flow_sflag;		/* Mt[tO */
static	char	*send_buf;		/* Mobt@擪|C^ */
static	char	*send_ptr;		/* Mobt@Jg|C^ */
static	int	send_len;		/* Mf[^ */
static	char	l_pad[10];		/* [fBOpbhf[^ */
static	int	l_pad_size;		/* [fBOpbhf[^ */
static	char	t_pad[10];		/* g[Opbhf[^ */
static	int	t_pad_size;		/* g[Opbhf[^ */
static	int	(*rs2_rcvfunc)(int);	/* [UM荞݊֐|C^ */
static	void	(far interrupt *save_vect)();	/* 荞݃xN^ۑGA */
static	int	vect_no;		/* 荞݃xN^ԍ */
static	u_char	imr_bit;		/* 荞݃}XNrbg */
static	int	ims_flg;		/* OF}X^@PFX[u */

/*	֐	*/
static	int	rs2_prmcheck(RSPRM *, u_int *, u_int *);
static	void	interrupt far	rs2_int(void);
static	void	outp2(int, int);

#pragma	check_stack-		/* X^bN`FbN */

/*=======================================================================
 |
 |		qr|QRQbI[v
 |
 |	int	rs2_open(rsprm)
 |
 |		RSPRM	*rsprm;		qr|QRQbI[vp[^
 |
 |		Ԓl			OFI[v
 |					PFI[vς
 |					QF[hp[^G[
 |					RFd[hp[^G[
 |					TFpeB[p[^G[
 |					UFLN^p[^G[
 |					VFXgbvrbgp[^G[
 |					WFt[p[^G[
 |					XFcsqp[^G[
 |					10FMobt@mێs
 |
 =======================================================================*/
int	rs2_open(RSPRM *rsprm)
{
	static	int	vect_no_tbl[4] = {	/* 荞݃xN^ԍ */
		0x0b, 0x0d, 0x0e, 0x11
	};
	static	u_char	imr_tbl[4] = {		/* 荞݃}XNrbg */
		0x08, 0x20, 0x40, 0x02
	};
	static	int	ims_tbl[4] = {		/* 荞݃}X^^X[u */
		0x00, 0x00, 0x00, 0x01
	};
	u_int	mode, cmd;
	int	err;

	/* I[vς݃`FbN */
	if (open_flag != 0)
		return(1);

	/* I[vp[^`FbN */
	if ((err = rs2_prmcheck(rsprm, &mode, &cmd)) != 0)
		return(err);

	/* Mobt@|C^AMobt@Z[u */
	rbufp = (int *)rsprm->bufp;
	rbufsize = rsprm->buf_size / sizeof(int);

	/* Mobt@m */
	if (rbufp == NULL) {
		if ((rbufp = malloc(rsprm->buf_size)) == NULL)
			return(10);
		alloc_flag = 1;
	} else
		alloc_flag = 0;

	_disable();		/* 荞݋֎~ */

	/* qr|QRQb荞݃}XN */
	outp2(IOP_RS2_IMR, imreg = 0);

	/* WQTP`n[hEFAZbg */
	outp2(IOP_RS2_MOD, 0);
	outp2(IOP_RS2_MOD, 0);
	outp2(IOP_RS2_MOD, 0);
	outp2(IOP_RS2_MOD, 0x40);

	/* [hWX^Zbg */
	outp2(IOP_RS2_MOD, mode);

	/* LN^Zbg */
	if (rsprm->sync_mode == SYNC) {
		outp2(IOP_RS2_SYN, rsprm->syn_chr);
		if ((mode & 0x80) == 0)
			outp2(IOP_RS2_SYN, rsprm->syn_chr >> 8);
	}

	/* R}hZbg */
	rs2_cmdreg = cmd;
	outp2(IOP_RS2_MOD, rs2_cmdreg | CMD_ER | CMD_EH);

	/* |C^JE^ */
	read_ptr = write_ptr = rcv_count = 0;

	/* xN^ԍo */
	vect_no = vect_no_tbl[inp(IOP_RS2_SGN) & 0x03];

	/* 荞݃xN^ۑ */
	save_vect = _dos_getvect(vect_no);

	/* 荞݃xN^Zbg */
	_dos_setvect(vect_no, rs2_int);

	/* 荞݃}XNrbgo */
	imr_bit = imr_tbl[inp(IOP_RS2_SGN) & 0x03];
	ims_flg = ims_tbl[inp(IOP_RS2_SGN) & 0x03];

	/* 荞݃}XN */
	if (ims_flg == 0)
		outp2(IOP_ICM_IMR, inp(IOP_ICM_IMR) & ~imr_bit);
	else {
		outp2(IOP_ICM_IMR, inp(IOP_ICM_IMR) & 0x7f);
		outp2(IOP_ICS_IMR, inp(IOP_ICS_IMR) & ~imr_bit);
	}
	outp2(IOP_RS2_IMR, imreg = IMR_RXRE);

	_enable();		/* 荞݋ */

	open_flag = 1;		/* I[vtOZbg */

	return(0);
}

/*=======================================================================
 |
 |		qr|QRQbăI[v
 |
 |	int	rs2_reopen(rsprm)
 |
 |		RSPRM	*rsprm;		qr|QRQbI[vp[^
 |
 |		Ԓl			OFI[v
 |					PFI[v
 |					QF[hp[^G[
 |					RFd[hp[^G[
 |					TFpeB[p[^G[
 |					UFLN^p[^G[
 |					VFXgbvrbgp[^G[
 |					WFt[p[^G[
 |					XFcsqp[^G[
 |
 =======================================================================*/
int	rs2_reopen(RSPRM *rsprm)
{
	u_int	mode, cmd;
	int	err;
	int	sync1_flag, sync1, sync2_flag, sync2;

	/* I[vς݃`FbN */
	if (open_flag == 0)
		return(1);

	/* I[vp[^`FbN */
	if ((err = rs2_prmcheck(rsprm, &mode, &cmd)) != 0)
		return(err);

	_disable();		/* 荞݋֎~ */

	/* qr|QRQb荞݃}XN */
	outp2(IOP_RS2_IMR, imreg = 0);

	/* LN^`FbN */
	sync1_flag = sync2_flag = 0;
	if (rsprm->sync_mode == SYNC) {
		sync1_flag = 1;
		sync1 = rsprm->syn_chr;
		if ((mode & 0x80) == 0) {
			sync2_flag = 1;
			sync2 = rsprm->syn_chr >> 8;
		}
	}

	/* WQTP`n[hEFAZbg */
	outp2(IOP_RS2_MOD, 0x40);

	/* [hWX^Zbg */
	outp2(IOP_RS2_MOD, mode);

	/* LN^Zbg */
	if (sync1_flag) {
		(void)outp(IOP_RS2_SYN, sync1);
		if (sync2_flag)
			(void)outp(IOP_RS2_SYN, sync2);
	}

	/* R}hZbg */
	rs2_cmdreg = cmd;
	(void)outp(IOP_RS2_MOD, rs2_cmdreg | CMD_ER | CMD_EH);

	/* |C^JE^ */
	read_ptr = write_ptr = rcv_count = 0;

	/* 荞݃}XN */
	outp2(IOP_RS2_IMR, imreg = IMR_RXRE);

	_enable();		/* 荞݋ */

	return(0);
}

/*=======================================================================
 |
 |		qr|QRQbI[vp[^`FbN
 |
 |	int	rs2_prmcheck(rsprm, mode, cmd)
 |
 |		RSPRM	*rsprm;		qr|QRQbI[vp[^
 |		u_int	*mode;		WQTP`[h
 |		u_int	*cmd;		WQTP`R}h
 |
 |		Ԓl			OFp[^
 |					QF[hp[^G[
 |					RFd[hp[^G[
 |					TFpeB[p[^G[
 |					UFLN^p[^G[
 |					VFXgbvrbgp[^G[
 |					WFt[p[^G[
 |					XFcsqp[^G[
 |
 =======================================================================*/
static	int	rs2_prmcheck(RSPRM *rsprm, u_int *mode, u_int *cmd)
{
	/* [hAR}h */
	*mode = 0;
	*cmd = 0;

	/* [hp[^`FbN */
	switch (rsprm->sync_mode) {
	case SYNC:		/* [h */
		break;
	case ASYNC:		/* 񓯊[h */
		*mode |= 0x02;
		break;
	default:		/* p[^G[ */
		return(2);
	}

	/* d[hp[^`FbN */
	switch (duplex = rsprm->duplex) {
	case DUPLEX_FULL:	/* Sd */
		*cmd |= CMD_RXE | CMD_TXE | CMD_RTS;
		break;
	case DUPLEX_HALF:	/* d */
		*cmd |= CMD_RXE;
		break;
	default:
		return(3);	/* p[^G[ */
	}

	/* peB[`FbN */
	switch (rsprm->parity) {
	case PARITY_NONE:	/* peB[ */
	case PARITY_EVEN:	/* peB[ */
	case PARITY_ODD:	/* peB[ */
		*mode |= rsprm->parity;
		break;
	default:		/* p[^G[ */
		return(5);
	}

	/* LN^`FbN */
	switch (rsprm->chr_len) {
	case CHR_5:		/* Trbg */
	case CHR_6:		/* Urbg */
	case CHR_7:		/* Vrbg */
	case CHR_8:		/* Wrbg */
		*mode |= rsprm->chr_len;
		break;
	default:		/* p[^G[ */
		return(6);
	}

	if (rsprm->sync_mode == ASYNC) {
		/* Xgbvrbg`FbN */
		switch (rsprm->stp_len) {
		case STP_1:	/* Prbg */
		case STP_1_5:	/* PDTrbg */
		case STP_2:	/* Qrbg */
			*mode |= rsprm->stp_len;
			break;
		default:	/* p[^G[ */
			return(7);
		}
	} else {
		/* LN^`FbN */
		if ((rsprm->syn_chr & 0xff00) == 0)
			*mode |= 0x80;
	}

	/* t[`FbN */
	switch (rsprm->flow_ctrl) {
	case FLOW_NONE:		/* t[䖳 */
	case FLOW_SOFT:		/* wnm^wnee */
	case FLOW_HARD:		/* qsr^bsr */
		flow_ctrl = rsprm->flow_ctrl;
		flow_on = rsprm->buf_size / 8;
		flow_off = rsprm->buf_size / 8 * 3;
		flow_rflag = 0;
		flow_sflag = 0;
		break;
	default:		/* p[^G[ */
		return(8);
	}

	/* csq`FbN */
	switch (rsprm->dtr) {
	case DTR_OFF:
		break;
	case DTR_ON:
		*cmd |= CMD_DTR;
		break;
	default:		/* p[^G[ */
		return(9);
	}

	return(0);
}

/*=======================================================================
 |
 |		qr|QRQbN[Y
 |
 |	void	rs2_close()
 |
 =======================================================================*/
void	rs2_close(void)
{
	/* I[vȂ牽Ȃ */
	if (open_flag == 0)
		return;

	_disable();		/* 荞݋֎~ */

	/* n[hEFAZbg */
	outp2(IOP_RS2_MOD, 0);
	outp2(IOP_RS2_MOD, 0);
	outp2(IOP_RS2_MOD, 0);
	outp2(IOP_RS2_MOD, 0x40);

	/* 荞݃}XN */
	if (ims_flg == 0)
		outp2(IOP_ICM_IMR, inp(IOP_ICM_IMR) | imr_bit);
	else
		outp2(IOP_ICS_IMR, inp(IOP_ICS_IMR) | imr_bit);
	outp2(IOP_RS2_IMR, imreg = 0);

	/* 荞݃xN^A */
	_dos_setvect(vect_no, save_vect);

	_enable();		/* 荞݋ */

	/* Mobt@mۂꍇ͉ */
	if (alloc_flag != 0)
		free(rbufp);

	rs2_cmdreg = 0;
	open_flag = 0;		/* I[vtOZbg */
}

/*=======================================================================
 |
 |		Mobt@`FbN
 |
 |	int	rs2_rxc()
 |
 |		Ԓl		M
 |
 =======================================================================*/
int	rs2_rxc(void)
{
	return(rcv_count);
}

/*=======================================================================
 |
 |		PM
 |
 |	int	rs2_get()
 |
 |		Ԓl		M
 |
 =======================================================================*/
int	rs2_get(void)
{
	int	c;

	/* M */
	while (rcv_count == 0)
		;

	_disable();		/* 荞݋֎~ */

	/* Po */
	c = rbufp[read_ptr++];
	if (read_ptr == rbufsize)
		read_ptr = 0;
	rcv_count--;

	/* t[ */
	switch (flow_ctrl) {
	case FLOW_SOFT:		/* wnm^wnee */
		if (flow_rflag != 0 && rcv_count < flow_on) {
			outp2(IOP_RS2_DAT, XON);	/* wnmM */
			flow_rflag = 0;
		}
		break;
	case FLOW_HARD:		/* qsr^bsr */
		if (flow_rflag != 0 && rcv_count < flow_on) {
			rs2_cmd(CMD_RTS, CMD_RTS);	/* qsrI */
			flow_rflag = 0;
		}
		break;
	}

	_enable();		/* 荞݋ */

	return(c);
}

/*=======================================================================
 |
 |		Mobt@NA
 |
 |	void	rs2_clear()
 |
 =======================================================================*/
void	rs2_clear(void)
{
	_disable();		/* 荞݋֎~ */

	/* |C^JE^ */
	read_ptr = write_ptr = rcv_count = 0;

	_enable();		/* 荞݋ */
}

/*=======================================================================
 |
 |		PM
 |
 |	void	rs2_put(c)
 |
 |		int	c;		M
 |
 =======================================================================*/
void	rs2_put(int c)
{
	/* t[ɂ鑗M҂킹 */
	while (flow_sflag != 0)
		;

	/* M */
	while ((inp(IOP_RS2_STS) & STS_TXRDY) == 0)
		;

	/* PM */
	outp2(IOP_RS2_DAT, c);
}

/*=======================================================================
 |
 |		ubNM
 |
 |	void	rs2_send(s, len)
 |
 |		char	*s;		M
 |		int	len;		
 |
 =======================================================================*/
void	rs2_send(char *s, int len)
{
	int	i;

	if (len == 0)
		return;

	if (duplex == DUPLEX_HALF) {
		/* MAM֎~AqsrI */
		rs2_cmd(CMD_TXE|CMD_RTS, CMD_TXE|CMD_RXE|CMD_RTS);
	}

	/* [fBOo`cM */
	for (i = 0; i < l_pad_size; i++)
		rs2_put(l_pad[i]);

	/* f[^M */
	while (len--)
		rs2_put(*s++);

	/* g[Oo`cM */
	for (i = 0; i < t_pad_size; i++)
		rs2_put(t_pad[i]);

	if (duplex == DUPLEX_HALF) {
		rs2_cmd(0, CMD_TXE);	/* M֎~ */

		/* MI҂ */
		while ((inp(IOP_RS2_STS) & STS_TXE) == 0)
			;
		/* MAqsrIt */
		rs2_cmd(CMD_RXE, CMD_RXE|CMD_RTS);
	}
}

/*=======================================================================
 |
 |		ubNMv
 |
 |	int	rs2_sendreq(s, len)
 |
 |		char	*s;		M
 |		int	len;		
 |
 |		Ԓl			OF@PFMobt@mێs
 |
 =======================================================================*/
int	rs2_sendreq(char *s, int len)
{
	int	data_size;

	if (len == 0)
		return(0);

	/* ݃f[^MȂ瑗MI܂ő҂ */
	while (send_len != 0)
		;

	/* f[^TCYvZ */
	data_size = l_pad_size + len + t_pad_size;

	/* Mf[^obt@m */
	if ((send_buf = malloc(data_size)) == NULL)
		return(1);

	/* Mf[^obt@Zbg */
	memcpy(send_buf, l_pad, l_pad_size);
	memcpy(send_buf+l_pad_size, s, len);
	memcpy(send_buf+l_pad_size+len, t_pad, t_pad_size);

	/* Mf[^AMf[^obt@|C^Zbg */
	send_len = data_size;
	send_ptr = send_buf;

	if (duplex == DUPLEX_HALF){
		/* MAM֎~AqsrI */
		rs2_cmd(CMD_TXE|CMD_RXE|CMD_RTS, CMD_TXE|CMD_RTS);
	}

	outp2(IOP_RS2_IMR, imreg |= IMR_TXRE); /* M荞݋ */

	return(0);
}

/*=======================================================================
 |
 |		f[^M҂
 |
 |	void	rs2_swait()
 |
 =======================================================================*/
void	rs2_swait(void)
{
	/* ݃f[^MȂ瑗MI܂ő҂ */
	while (send_len != 0)
		;

	/* MI҂ */
	while ((inp(IOP_RS2_STS) & STS_TXE) == 0)
		;
}

/*=======================================================================
 |
 |		t[ݒ
 |
 |	void	rs2_flow(ctrl)
 |
 |		int	ctrl;		t[
 |
 =======================================================================*/
void	rs2_flow(int ctrl)
{
	flow_ctrl = ctrl;
}

/*=======================================================================
 |
 |		o`cݒ
 |
 |	void	rs2_pad(lpad, lpadsize, tpad, tpadsize)
 |
 |		char	*lpad;		[fBOpbhf[^
 |		int	lpad_size;	[fBOpbhf[^
 |		char	*tpad;		g[Opbhf[^
 |		int	tpadsize;	g[Opbhf[^
 |
 =======================================================================*/
void	rs2_pad(char *lpad, int lpadsize, char *tpad, int tpadsize)
{
	memcpy(l_pad, lpad, lpadsize);
	l_pad_size = lpadsize;
	memcpy(t_pad, tpad, tpadsize);
	t_pad_size = tpadsize;
}

/*=======================================================================
 |
 |		M荞ݏݒ
 |
 |	void	rs2_rcvint(func)
 |
 |		int	(*func)();	M荞ݏ
 |
 =======================================================================*/
void	rs2_rcvint(int (*func)(int))
{
	rs2_rcvfunc = func;
}

/*=======================================================================
 |
 |		G^[ng[hZbg
 |
 |	void	rs2_ehm()
 |
 =======================================================================*/
void	rs2_ehm(void)
{
	outp2(IOP_RS2_MOD, rs2_cmdreg | 0x80);
}

/*=======================================================================
 |
 |		crq`FbN
 |
 |	int	rs2_dsr()
 |
 |		Ԓl		OFcrqIt@PFcrqI
 |
 =======================================================================*/
int	rs2_dsr(void)
{
	return(inp(IOP_RS2_STS) & STS_DSR ? 1 : 0);
}

/*=======================================================================
 |
 |		LA`FbN
 |
 |	int	rs2_cd()
 |
 |		Ԓl		OFLAIt@PFLAI
 |
 =======================================================================*/
int	rs2_cd(void)
{
	return(inp(IOP_RS2_SGN) & SGN_CD ? 0 : 1);
}

/*=======================================================================
 |
 |		bsr`FbN
 |
 |	int	rs2_cts()
 |
 |		Ԓl		OFbsrIt@PFbsrI
 |
 =======================================================================*/
int	rs2_cts(void)
{
	return(inp(IOP_RS2_SGN) & SGN_CS ? 0 : 1);
}

/*=======================================================================
 |
 |		bh`FbN
 |
 |	int	rs2_ci()
 |
 |		Ԓl		OFbhIt@PFbhI
 |
 =======================================================================*/
int	rs2_ci(void)
{
	return(inp(IOP_RS2_SGN) & SGN_CI ? 0 : 1);
}

/*=======================================================================
 |
 |		csq
 |
 |	void	rs2_dtr(dtr);
 |
 |		int	sw;		OFcsqIt@OFcsqI
 |
 =======================================================================*/
void	rs2_dtr(int dtr)
{
	_disable();

	if (dtr == 0)
		rs2_cmdreg &= ~CMD_DTR;
	else
		rs2_cmdreg |= CMD_DTR;

	outp2(IOP_RS2_MOD, rs2_cmdreg);

	_enable();
}

/*=======================================================================
 |
 |		qsr
 |
 |	void	rs2_rts(rts);
 |
 |		int	sw;		OFqsrIt@OFqsrI
 |
 =======================================================================*/
void	rs2_rts(int rts)
{
	_disable();

	if (rts == 0)
		rs2_cmdreg &= ~CMD_RTS;
	else
		rs2_cmdreg |= CMD_RTS;

	outp2(IOP_RS2_MOD, rs2_cmdreg);

	_enable();
}

/*=======================================================================
 |
 |		u[NMo
 |
 |	void	rs2_break(sw);
 |
 |		int	sw;		  OFu[NMIt
 |					OFu[NMI
 |
 =======================================================================*/
void	rs2_break(int sw)
{
	_disable();

	if (sw == 0)
		rs2_cmdreg &= ~CMD_SBRK;
	else
		rs2_cmdreg |= CMD_SBRK;

	outp2(IOP_RS2_MOD, rs2_cmdreg);

	_enable();
}

/*=======================================================================
 |
 |		R}ho
 |
 |	void	rs2_cmd(cmd, mask)
 |
 |		int	cmd;		R}h
 |		int	mask;		}XNf[^
 |
 =======================================================================*/
void	rs2_cmd(int cmd, int mask)
{
	_disable();
	rs2_cmdreg = (cmd & mask) | (rs2_cmdreg & ~mask);
	outp2(IOP_RS2_MOD, rs2_cmdreg);
	_enable();
}

/*=======================================================================
 |
 |		Xe[^Xǂݍ
 |
 |	int	rs2_sts()
 |
 |		Ԓl			Xe[^X
 |
 =======================================================================*/
int	rs2_sts(void)
{
	return(inp(IOP_RS2_STS));
}

/*=======================================================================
 |
 |		荞ݏ
 |
 |	void	interrupt far	rs2_int()
 |
 =======================================================================*/
static	void	interrupt far	rs2_int(void)
{
	int	c, sts;

	sts = inp(IOP_RS2_STS);		/* Xe[^Xǂݍ */

	/* M荞ݏ */
	if (sts & STS_RXRDY) {
		/* Mǂݍ */
		c = inp(IOP_RS2_DAT);

		/* Xe[^Xǂݍ */
		if (sts & 0x38) {
			/* G[Zbg */
			outp2(IOP_RS2_MOD, rs2_cmdreg | 0x10);
			c |= (sts & 0x38) << 8;
		}

		/* [UM荞݊֐Ăяo */
		if (rs2_rcvfunc != NULL)
			c = (*rs2_rcvfunc)(c);

		if (c == -1)
			;
		else if (flow_ctrl == FLOW_SOFT && c == XOFF) {
			flow_sflag = 1;
			if (send_len != 0) {
				/* M֎~ */
				outp2(IOP_RS2_MOD, rs2_cmdreg &= ~CMD_TXE);
			}
		} else if (flow_ctrl == FLOW_SOFT && c == XON) {
			flow_sflag = 0;
			if (send_len != 0) {
				/* M */
				outp2(IOP_RS2_MOD, rs2_cmdreg |= CMD_TXE);
			}
		} else if (rcv_count < rbufsize) {
			/* Mobt@ɃZbg */
			rbufp[write_ptr++] = c;

			/* ݃|C^̍XV */
			if (write_ptr == rbufsize)
				write_ptr = 0;

			/* MXV */
			rcv_count++;

			/* t[ */
			switch (flow_ctrl) {
			case FLOW_SOFT:
				if (flow_rflag == 0 && rcv_count > flow_off) {
					/* wneeM */
					if (sts & STS_TXRDY) {
						outp2(IOP_RS2_DAT, XOFF);
						flow_rflag = 1;
					}
				}
				break;
			case FLOW_HARD:
				if (flow_rflag == 0 && rcv_count > flow_off) {
					/* qsrIt */
					outp2(IOP_RS2_MOD, rs2_cmdreg &= ~CMD_RTS);
					flow_rflag = 1;
				}
				break;
			}
		}
	}

	/* dlosx荞ݏ */
	if ((imreg & IMR_TXEE) && (sts & STS_TXE)) {
		/* dlosx荞݋֎~ */
		outp2(IOP_RS2_IMR, imreg &= ~IMR_TXEE);

		if (duplex == DUPLEX_HALF) {
			/* MAqsrIt */
			rs2_cmdreg = rs2_cmdreg & ~(CMD_RXE|CMD_RTS) | CMD_RXE;
			outp2(IOP_RS2_MOD, rs2_cmdreg);
		}
	}

	/* M荞ݏ */
	if (send_len != 0 && (sts & STS_TXRDY)) {
		outp2(IOP_RS2_DAT, *send_ptr++);		/* ̂PM */
		if (--send_len == 0) {
			if (duplex == DUPLEX_HALF) {
				/* M֎~ */
				outp2(IOP_RS2_MOD, rs2_cmdreg &= ~CMD_TXE);
			}
			/* M荞݋֎~Edlosx荞݋ */
			outp2(IOP_RS2_IMR, imreg = imreg & ~IMR_TXRE | IMR_TXEE);
			free(send_buf);		/* Mobt@ */
		}
	}

	/* 荞݃}XN */
	outp2(IOP_RS2_IMR, 0x00);

	/* 荞ݏIʒm */
	if (ims_flg == 0)
		outp2(IOP_ICM_EOI, 0x20);
	else {
		outp2(IOP_ICS_EOI, 0x20);
		outp2(IOP_ICS_EOI, 0x0b);
		if (inp(IOP_ICS_EOI) == 0)
			outp2(IOP_ICM_EOI, 0x20);
	}

	/* 荞݃}XN */
	outp2(IOP_RS2_IMR, imreg);
}

/*=======================================================================
 |
 |		|[g
 |
 |	void	outp2(int port, int databyte)
 |
 |		int	port;		|[gԍ
 |		int	databyte;	o͂l
 |
 =======================================================================*/
static	void	outp2(int port, int databyte)
{
	(void)outp(port, databyte);
}
